## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%undefine _auto_set_build_flags

%global srcver  0.25.2
%global pkgsrc  %{srcver}%{?srcpre:-%{srcpre}}

Name:           harec
Version:        %{srcver}%{?srcpre:~%{srcpre}}
Release:        %autorelease
Summary:        Hare bootstrap compiler

License:        GPL-3.0-only
URL:            https://git.sr.ht/~sircmpwn/harec
Source0:        %{url}/archive/%{pkgsrc}.tar.gz

BuildRequires:  make
BuildRequires:  gcc
BuildRequires:  qbe
Requires:       qbe

ExclusiveArch:  %hare_arches

%description
This is a Hare compiler written in C11 for POSIX-compatible systems.
It is intended as a bootstrap compiler and using the Hare standard
library is recommended for production use.


%prep
%autosetup -n %{name}-%{pkgsrc}


%conf
# This is a modified copy of the configs/linux.mk template stripped of
# developer flags, relying on RPM macros where applicable. Changes for
# config.mk are usually highlighted in release notes, but changes to
# the configs/linux.mk template should be checked before upgrading to
# a new release.
tee config.mk <<'EOF'
# install locations
PREFIX = %{_prefix}
BINDIR = %{_bindir}

# variables used during build
PLATFORM = %{_os}
ARCH = %{_arch}
HARECFLAGS =
QBEFLAGS =
ASFLAGS =
LDLINKFLAGS = --gc-sections -z noexecstack
CFLAGS = -std=c11 -D_XOPEN_SOURCE=700 -Iinclude %{build_cflags}
LDFLAGS = %{build_ldflags}
LIBS = -lm

CC = gcc
AS = as
LD = ld
QBE = qbe

# build locations
HARECACHE = .cache
BINOUT = .bin

# variables that will be embedded in the binary with -D definitions
DEFAULT_TARGET = $(ARCH)
VERSION = %{version}-%{release}
EOF


%build
%make_build


%install
%make_install


%check
%make_build check


%files
%license COPYING
%doc README.md docs/*.txt
%{_bindir}/harec


%changelog
## START: Generated by rpmautospec
* Fri Jul 11 2025 Dridi Boukelmoune <dridi.boukelmoune@gmail.com> - 0.25.2-1
- Uncommitted changes

* Mon Jun 30 2025 Dridi Boukelmoune <dridi.boukelmoune@gmail.com> - 0.24.2-7
- Add a note for the %%conf section

* Fri Jun 27 2025 Dridi Boukelmoune <dridi.boukelmoune@gmail.com> - 0.24.2-6
- Adopt %%hare_arches macro

* Fri Jun 27 2025 Dridi Boukelmoune <dridi.boukelmoune@gmail.com> - 0.24.2-5
- No need to set build flags

* Fri Jun 27 2025 Dridi Boukelmoune <dridi.boukelmoune@gmail.com> - 0.24.2-4
- Generate wholesale config.mk

* Fri Jan 17 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.24.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.24.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Mon Jul 15 2024 Dridi Boukelmoune <dridi.boukelmoune@gmail.com> - 0.24.2-1
- Update to 0.24.2

* Wed Jul 03 2024 Mike Rochefort <mroche@omenos.dev> - 0.24.0-1
- Revert "Update to 0.24.2-rc1"

* Wed Jul 03 2024 Mike Rochefort <mroche@omenos.dev> - 0.24.2~rc1-1
- Update to 0.24.2-rc1

* Fri Feb 16 2024 Timothée Floure <work@tfloure.ch> - 0.24.0-1
- Rebase on 0.24.0

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0^20230610git174aef48-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jun 10 2023 Timothée Floure <fnux@fedoraproject.org> - 0^20230610git174aef48-1
- Upstream rebase, early June 2023

* Sat Apr 15 2023 Dridi Boukelmoune <dridi@fedoraproject.org> - 0^20230316gitdd50ca77-1
- Updated to March 2023

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0^20221126gita1aa5039-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Dec 22 2022 Benson Muite <benson_muite@emailplus.org> - 0^20221126gita1aa5039-3
- Move configure to build section

* Mon Dec 19 2022 Benson Muite <benson_muite@emailplus.org> - 0^20221126gita1aa5039-2
- Update build flags and versioning based on review

* Fri Dec 16 2022 Benson Muite <benson_muite@emailplus.org> - 0^20221126gita1aa5039-1
- Initial packaging

## END: Generated by rpmautospec
